#include <stdio.h>
#include <string.h>

#include "pattern.h"
#include "board.h"


/* rbg񑀍 */
#define REV3(p) ((p >> 4) | (p & 0xc) | ((p & 0x3) << 4))
#define REV2(p) ((p >> 2) | ((p & 0x3) << 2))

/* ߖT̍W */
#define N	(-BOARD_SIZE)
#define S	BOARD_SIZE
#define E	1
#define W	-1


/*------------------------------------------------------------------*/
/* O[oϐ                                                   */
/*------------------------------------------------------------------*/

/* XVprbg}XN */
static int update_mask[8][3] = {
	{0, 0x4000, 0x8000},
	{0, 0x1000, 0x2000},
	{0, 0x0400, 0x0800},
	{0, 0x0100, 0x0200},
	{0, 0x0040, 0x0080},
	{0, 0x0010, 0x0020},
	{0, 0x0004, 0x0008},
	{0, 0x0001, 0x0002}
};

static int dia_update_mask[12][3] = {
	{0, 0x000001, 0x000002},
	{0, 0x000004, 0x000008},
	{0, 0x000010, 0x000020},
	{0, 0x000040, 0x000080},
	{0, 0x000100, 0x000200},
	{0, 0x000400, 0x000800},
	{0, 0x001000, 0x002000},
	{0, 0x004000, 0x008000},
	{0, 0x010000, 0x020000},
	{0, 0x040000, 0x080000},
	{0, 0x100000, 0x200000},
	{0, 0x400000, 0x800000}
};


/*-------------------------------------------------------------------*/
/* ݒ                                                          */
/*-------------------------------------------------------------------*/
void
ClearPattern3( int *pat3 )
{
	int y;

	memset(pat3, 0, sizeof(int)*BOARD_MAX);

	for( y=BOARD_START; y<=BOARD_END; y++ ){
		pat3[POS(y,BOARD_START)] |= 0x003F;	// 
		pat3[POS(BOARD_END,y)]	 |= 0xC330;	// E
		pat3[POS(y,BOARD_END)]	 |= 0xFC00;	// 
		pat3[POS(BOARD_START,y)] |= 0x0CC3;	// 
	}
}


/*-------------------------------------------------------------------*/
/* XV                                                              */
/*-------------------------------------------------------------------*/
void
UpdatePattern3Empty( int *pat3, int pos )
{
	pat3[pos + NW] &= 0x3FFF;
	pat3[pos + N ] &= 0xCFFF;
	pat3[pos + NE] &= 0xF3FF;
	pat3[pos + W ] &= 0xFCFF;
	pat3[pos + E ] &= 0xFF3F;
	pat3[pos + SW] &= 0xFFCF;
	pat3[pos + S ] &= 0xFFF3;
	pat3[pos + SE] &= 0xFFFC;
}

void
UpdatePattern3Stone( int *pat3, int color, int pos )
{
	pat3[pos + NW] |= update_mask[0][color];
	pat3[pos + N ] |= update_mask[1][color];
	pat3[pos + NE] |= update_mask[2][color];
	pat3[pos + W ] |= update_mask[3][color];
	pat3[pos + E ] |= update_mask[4][color];
	pat3[pos + SW] |= update_mask[5][color];
	pat3[pos + S ] |= update_mask[6][color];
	pat3[pos + SE] |= update_mask[7][color];
}


/*-------------------------------------------------------------------*/
/* p^[Ԃ                                                */
/*-------------------------------------------------------------------*/
void
Pattern3Transpose8( int pat3, int *transp )
{
	transp[0] = pat3;
	transp[1] = Pattern3VerticalMirror(pat3);
	transp[2] = Pattern3HorizontalMirror(pat3);
	transp[3] = Pattern3VerticalMirror(transp[2]);
	transp[4] = Pattern3Rotate90(pat3);
	transp[5] = Pattern3Rotate90(transp[1]);
	transp[6] = Pattern3Rotate90(transp[2]);
	transp[7] = Pattern3Rotate90(transp[3]);
}

void
Pattern3Transpose16( int pat3, int *transp )
{
	transp[0] = pat3;
	transp[1] = Pattern3VerticalMirror(pat3);
	transp[2] = Pattern3HorizontalMirror(pat3);
	transp[3] = Pattern3VerticalMirror(transp[2]);
	transp[4] = Pattern3Rotate90(pat3);
	transp[5] = Pattern3Rotate90(transp[1]);
	transp[6] = Pattern3Rotate90(transp[2]);
	transp[7] = Pattern3Rotate90(transp[3]);
	transp[8] = Pattern3Reverse(transp[0]);
	transp[9] = Pattern3Reverse(transp[1]);
	transp[10] = Pattern3Reverse(transp[2]);
	transp[11] = Pattern3Reverse(transp[3]);
	transp[12] = Pattern3Reverse(transp[4]);
	transp[13] = Pattern3Reverse(transp[5]);
	transp[14] = Pattern3Reverse(transp[6]);
	transp[15] = Pattern3Reverse(transp[7]);
}


/*-------------------------------------------------------------------*/
/* F̔]                                                          */
/*-------------------------------------------------------------------*/
int
Pattern3Reverse( int pat3 )
{
	return ((pat3 >> 1) & 0x5555) | ((pat3 & 0x5555) << 1);
}


/*-------------------------------------------------------------------*/
/* ㉺Ώ                                                          */
/*-------------------------------------------------------------------*/
int
Pattern3VerticalMirror( int pat3 )
{
	return ((pat3 & 0xfc00) >> 10) | (pat3 & 0x03c0) | ((pat3 & 0x003f) << 10);
}


/*-------------------------------------------------------------------*/
/* EΏ                                                          */
/*-------------------------------------------------------------------*/
int
Pattern3HorizontalMirror( int pat3 )
{
	return (REV3((pat3 & 0xfc00) >> 10) << 10)
		| (REV2((pat3 & 0x03c0) >> 6) << 6)
		| REV3((pat3 & 0x003f));
}


/*-------------------------------------------------------------------*/
/* 90x]                                                          */
/*-------------------------------------------------------------------*/
int
Pattern3Rotate90(int pat3)
{
	/* 0 1 2    2 4 7
	 * 3   4 -> 1   6
	 * 5 6 7    0 3 5 */

	return ((pat3 & 0x0003) << 10)
		 | ((pat3 & 0x0c0c) << 4)
		 | ((pat3 & 0x3030) >> 4)
		 | ((pat3 & 0x00c0) << 6)
		 | ((pat3 & 0x0300) >> 6)
		 | ((pat3 & 0xc000) >> 10);
}


/*-------------------------------------------------------------------*/
/* ݒ Diamond                                                  */
/*-------------------------------------------------------------------*/
void
ClearDiamond( int *dia )
{
	int y;

	/*  */
	memset(dia, 0, sizeof(int)*BOARD_MAX);

	for( y=BOARD_START; y<=BOARD_END; y++ ){
		dia[POS(y,BOARD_START)] |= 0xC00F03;	// 
		dia[POS(BOARD_END,y)]	|= 0x00FC0C;	// E
		dia[POS(y,BOARD_END)]	|= 0x0FC030;	// 
		dia[POS(BOARD_START,y)] |= 0xFC00C0;	// 

		dia[POS(y,BOARD_START+1)] |= 0x000300;	// 
		dia[POS(BOARD_END-1,y)]	  |= 0x003000;	// E
		dia[POS(y,BOARD_END-1)]   |= 0x030000;	// 
		dia[POS(BOARD_START+1,y)] |= 0x300000;	// 
	}
}


/*-------------------------------------------------------------------*/
/* XV                                                              */
/*-------------------------------------------------------------------*/
void
UpdateDiamondEmpty( int *dia, int pos )
{
	dia[(pos + S)] &= 0xFFFFFC;
	dia[(pos + W)] &= 0xFFFFF3;
	dia[(pos + N)] &= 0xFFFFCF;
	dia[(pos + E)] &= 0xFFFF3F;
	dia[(pos + SS)] &= 0xFFFCFF;
	dia[(pos + SW)] &= 0xFFF3FF;
	dia[(pos + WW)] &= 0xFFCFFF;
	dia[(pos + NW)] &= 0xFF3FFF;
	dia[(pos + NN)] &= 0xFCFFFF;
	dia[(pos + NE)] &= 0xF3FFFF;
	dia[(pos + EE)] &= 0xCFFFFF;
	dia[(pos + SE)] &= 0x3FFFFF;
}

void
UpdateDiamondStone( int *dia, int color, int pos )
{
	dia[(pos + S)] |= dia_update_mask[0][color];
	dia[(pos + W)] |= dia_update_mask[1][color];
	dia[(pos + N)] |= dia_update_mask[2][color];
	dia[(pos + E)] |= dia_update_mask[3][color];
	dia[(pos + SS)] |= dia_update_mask[4][color];
	dia[(pos + SW)] |= dia_update_mask[5][color];
	dia[(pos + WW)] |= dia_update_mask[6][color];
	dia[(pos + NW)] |= dia_update_mask[7][color];
	dia[(pos + NN)] |= dia_update_mask[8][color];
	dia[(pos + NE)] |= dia_update_mask[9][color];
	dia[(pos + EE)] |= dia_update_mask[10][color];
	dia[(pos + SE)] |= dia_update_mask[11][color];
}