#ifndef _UCT_H_
#define _UCT_H_


#include <windows.h>
#include <time.h>
#include "board.h"
#include "mt19937p.h"


/* Xbh */
#define THREAD_NUM 4

/* [h */
//#define UCT_MODE_1	// vCAEgŒ
#define UCT_MODE_2	// vlԂŒ
//#define UCT_MODE_3	// c莞ԂAgp鎞ԂvZ

#define CONST_PLAYOUT	10000	// vCAEg
#define CONST_THINKING_TIME	0.9 //vl

#define PLAYOUT_SPEED	2500	// Ֆʂ̃vCAEgx PO/sec

#define ALL_THINKING_TIME	90		// vl
#define THINKING_TIME_RATE	14		// c莞Ԃɑ΂āAgp鎞Ԃ̊ : 1/THINKING_TIME_RATE

#define PASS_RATE_1	0.98	// pX@1Oɑ肪pX
#define PASS_RATE_2	0.95	// pX@pXĂȏ
#define RESIGN_RATE 0.80	// 

/* m[h */
#define MAX_NODE 1000000	// őm[h
#define ROOT 0				// [g

/* UCTp[^ */
#define FPU 1.1				// 擪Œً}x
#define EQUIVALENCE	1000	// RAVE̓p[^
#define PW	1.4				// Progressive Widening


/*------------------------------------------------------------------*/
/* \                                                           */
/*------------------------------------------------------------------*/

/* Xbh֐̈f[^ */
typedef struct _thread_arg {
	int thread_no;
	struct game *game;
	int color;
} thread_arg_t;

/* m[h */
struct node {
	int pos;
	int win;			// 
	int move_count;		// 
	int rave_win;		// RAVȄ
	int rave_count;		// RAVẺ
	int rave_sum;		// qm[hrave_count̍v
	int parent;			// em[h
	int parent_threshold;	// e臒l
	int child_origin;	// qm[ḧʒu
	int child_num;		// Sqm[h̐
	int width;			// T
	float rate;			// [g
};

/*  */
struct move_count {
	int colors[3];
};


/*------------------------------------------------------------------*/
/* ֐                                                             */
/*------------------------------------------------------------------*/

/*  */
void InitializeUCTMove( void );

/* (UCT) */
int UCTMove( struct game *game, int color );

/*vCAEg*/
void ParallelPlayOut( void *arg );

/* 1vCAEg */
void OnePlayOut( struct game *game, int color, struct mt19937p *mt );

/* [g̓WJ */
void RootExpantion( struct game *game, int color );

/* m[hWJ */
void NodeExpantion( struct game *game, int color, int index );

/* m[h̃[eBO */
void RatingNode( struct game *game, int color, int index );

/* m[h[gŔr */
int CompareRate(const void* n1, const void* n2);

/* m[hK񐔂Ŕr */
int CompareMoveCount(const void *n1, const void *n2);

/* őUCBlqm[hԂ */
int DecideByUCB( int index );

/* XV */
void UpdateData( int color, int index, int result, struct move_count *move_count );

/* Ravẻ񐔂XV */
void UpdateRaveCount( int color, int index, int result, struct move_count *move_count );

/* \ */
void DisplayCandidates( void );

/* Ԍv */
double GetSpendTime(clock_t start_time);


#endif  /* _UCT_H_ */